<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Project Code</label>

            <b-form-input
              size="lg"
              v-model="form.project.code"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Project Name</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="form.project.name"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nickname</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="form.project.nickname"
              disabled
            ></b-form-input>
          </div>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Tanggal</label>

            <b-form-input
              id="input-large"
              size="lg"
              type="date"
              v-model="form.date"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Tempat</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="form.place"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Agenda</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="form.subject"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Pimpinan</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="form.leader"
              disabled
            ></b-form-input>
          </div>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <b-tabs content-class="mt-3">
        <b-tab title="Point MOM" active>
          <div class="d-flex justify-content-end mt-5 mb-5">
            <b-button
                class="ml-auto"
                variant="success"
            >
              <i class="flaticon2-plus"></i> Tambah Point MOM
            </b-button>
          </div>

          <complete-table :data="momPoints" :loading="loading">
            <template #header>
              <tr class="text-left">
                <th class="pl-7">Point</th>
                <th class="pl-7">Uraian</th>
                <th class="pl-7">Analisa Penyebab</th>
                <th class="pl-7">Deadline</th>
                <th class="pl-7">Status</th>
                <th class="pl-7">PIC</th>
                <th class="pl-7">Tindak Lanjut</th>
                <th class="pl-7">Aksi</th>
              </tr>
            </template>

            <template #body>
              <template v-for="(point, i) in momPoints">
                <tr v-bind:key="i" class="border-0">
                  <td class="pl-0 pt-8" style="min-width: 250px">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ point.point }}
                    </span>
                  </td>

                  <td class="pl-0 pt-8" style="min-width: 250px">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ point.description }}
                    </span>
                  </td>

                  <td class="pl-0 pt-8">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ point.cause }}
                    </span>
                  </td>

                  <td class="pl-0 pt-8" style="min-width: 200px">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ point.deadline }}
                    </span>
                  </td>

                  <td class="pl-0 pt-8">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ point.status }}
                    </span>
                  </td>

                  <td class="pl-0 pt-8" style="min-width: 250px">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ point.pic ? point.pic.name : "-" }}
                    </span>
                  </td>

                  <td class="pl-0 pt-8" style="min-width: 150px">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ point.follow_up }}
                    </span>
                  </td>

                  <td class="pl-0 pt-8" style="min-width: 150px">
                    <a
                      class="btn btn-light-success font-weight-bolder font-size-sm mr-2"
                    >
                      <i class="flaticon-edit"></i>
                    </a>

                    <a
                      class="btn btn-light-danger font-weight-bolder font-size-sm mr-2"
                    >
                      <i class="flaticon2-rubbish-bin-delete-button"></i>
                    </a>
                  </td>
                </tr>
              </template>
            </template>
          </complete-table>

          <div class="d-flex justify-content-end mt-5">
            <b-button
                class="ml-auto"
                variant="success"
            >
              <i class="flaticon2-check-mark"></i> Simpan
            </b-button>
          </div>
        </b-tab>

        <b-tab title="Daftar Hadir">
          <div class="d-flex justify-content-end mt-5 mb-5">
            <b-button
                class="ml-auto"
                variant="success"
            >
              <i class="flaticon2-plus"></i> Tambah Peserta
            </b-button>
          </div>

          <complete-table :data="attendants" :loading="loading">
            <template #header>
              <tr class="text-left">
                <th class="pl-7">Nama</th>
                <th class="pl-7">Jabatan</th>
                <th class="pl-7">Email</th>
                <th class="pl-7">Tanda Tangan</th>
                <th class="pl-7">Aksi</th>
              </tr>
            </template>

            <template #body>
              <template v-for="(attendant, i) in attendants">
                <tr v-bind:key="i" class="border-0">
                  <td class="pl-0 pt-8" style="min-width: 200px">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ attendant.name }}
                    </span>
                  </td>

                  <td class="pl-0 pt-8" style="min-width: 200px">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ attendant.position }}
                    </span>
                  </td>

                  <td class="pl-0 pt-8">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ attendant.email }}
                    </span>
                  </td>

                  <td class="pl-0 pt-8" style="min-width: 200px">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ attendant.signature }}
                    </span>
                  </td>

                  <td class="pl-0 pt-8" style="min-width: 150px">
                    <a
                      class="btn btn-light-success font-weight-bolder font-size-sm mr-2"
                    >
                      <i class="flaticon-edit"></i>
                    </a>

                    <a
                      class="btn btn-light-danger font-weight-bolder font-size-sm"
                    >
                      <i class="flaticon2-rubbish-bin-delete-button"></i>
                    </a>
                  </td>
                </tr>
              </template>
            </template>
          </complete-table>

          <div class="d-flex justify-content-end mt-5">
            <b-button
                class="ml-auto"
                variant="success"
            >
              <i class="flaticon2-check-mark"></i> Simpan
            </b-button>
          </div>
        </b-tab>

        <b-tab title="Lampiran">
          <div class="d-flex justify-content-end mt-5 mb-5">
            <b-button
                class="ml-auto"
                variant="success"
            >
              <i class="flaticon2-plus"></i> Tambah Lampiran
            </b-button>
          </div>

          <complete-table :data="files" :loading="loading">
            <template #header>
              <tr class="text-left">
                <th class="pl-7">File</th>
                <th class="pl-7">Aksi</th>
              </tr>
            </template>

            <template #body>
              <template v-for="(file, i) in files">
                <tr v-bind:key="i" class="border-0">
                  <td class="pl-0 pt-8" style="min-width: 200px">
                    <span
                        class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ file.filename }}
                    </span>
                  </td>

                  <td class="pl-0 pt-8" style="min-width: 150px">
                    <a
                        class="btn btn-light-success font-weight-bolder font-size-sm mr-2"
                    >
                      <i class="flaticon-edit"></i>
                    </a>

                    <a
                        class="btn btn-light-danger font-weight-bolder font-size-sm mr-2"
                    >
                      <i class="flaticon2-rubbish-bin-delete-button"></i>
                    </a>
                  </td>
                </tr>
              </template>
            </template>
          </complete-table>

          <div class="d-flex justify-content-end mt-5">
            <b-button
                class="ml-auto"
                variant="success"
            >
              <i class="flaticon2-check-mark"></i> Simpan
            </b-button>
          </div>
        </b-tab>
      </b-tabs>
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { mapState } from "vuex";
import { GET_MEETING_BY_ID } from "../../../../core/services/store/meeting.module";
import CompleteTable from "../../../content/widgets/advance-table/CompleteTable";
// import OnEditRow from "../../../content/widgets/advance-table/row/OnEditRow";

export default {
  name: "MeetingUpdate",
  components: {
    CompleteTable
    // OnEditRow,
  },
  data() {
    return {
      form: {
        project: {
          code: null,
          nickname: null,
          name: null
        },
        code: null,
        date: null,
        place: null,
        subject: null,
        pic: null,
        leader: null,
        division: null,
        department: null
      },
      files: [],
      attendants: [],
      momPoints: [],
      selectedParticipant: {
        id: null
      },
      editIndex: null
    };
  },

  computed: {
    ...mapState({
      loading: state => state.meeting.loading,
      meeting: state => state.meeting.meeting?.data
    })
  },

  watch: {
    meeting() {
      Object.assign(this.form, {
        project: {
          code: this.meeting?.meeting?.project?.code,
          nickname: this.meeting?.meeting?.project?.nickname,
          name: this.meeting?.meeting?.project?.name
        },
        code: this.meeting?.meeting?.code,
        date: this.meeting?.meeting?.date?.split(" ")[0],
        place: this.meeting?.meeting?.place,
        subject: this.meeting?.meeting?.subject,
        pic: this.meeting?.meeting?.pic,
        leader: this.meeting?.meeting?.leader,
        division: this.meeting?.meeting?.division,
        department: this.meeting?.meeting?.department
      });

      this.momPoints = this.meeting?.mom_point;
      this.attendants = this.meeting?.attendant;
      this.files = this.meeting?.file;
    }
  },

  methods: {
    getMeetingDetail() {
      this.$store.dispatch(GET_MEETING_BY_ID, {
        id: this.$route.params.id
      });
    },

    toIndexPage() {
      this.$router.push({
        name: "meeting"
      });
    }
  },

  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Detail Meeting" }]);

    this.getMeetingDetail();
  }
};
</script>
